#C64Studio.MetaData.BASIC:8193,BASIC V10
#--------------------------------------------------------------------------------------------------------------------------
# DALEK ATTACK FOR THE MEGA65
# BY PRINCE / PHAZE101
#
# NEEDS MEGA65 ROM 920346
#
# GAME LINK - https://phaze101.itch.io/dalekattack
# GAME VIDEO - https://youtu.be/LlYEyKOP1EY
#--------------------------------------------------------------------------------------------------------------------------

3000 FAST40
3010 CURSOR OFF
3020 SCREEN CLR
3030 BORDER 0
3040 DIM T(50,3)                         : REM DALEK STRUCTURE


3050 PALETTE COLOR 16,15, 0,15
3060 PALETTE COLOR 17,15,15,0

3070 CHARDEF 87,$00,$38,$4C,$9E,$BE,$FE,$7C,$38 : REM BOMB
3080 CHARDEF 83,$7C,$54,$38,$10,$7C,$BA,$28,$6C : REM PLAYER
3090 CHARDEF 35,$00,$DF,$DF,$CB,$04,$FB,$FB,$F1 : REM WALL - #
3100 CHARDEF 94,$18,$18,$3F,$3C,$5A,$7E,$DB,$FF : REM DALEK - 

#--------------------------------------------------------------------------------------------------------------------------
# INTRO SCREEN
#--------------------------------------------------------------------------------------------------------------------------

5000 SCREEN CLR:COLOR 3
5010 CURSOR 3,1 :PRINT "                                      "
5020 CURSOR 3,2 :PRINT "                                                         "
5030 CURSOR 3,3 :PRINT "                                                         "
5040 CURSOR 3,4 :PRINT "                                                         "
5050 CURSOR 3,5 :PRINT "                                              "
5060 CURSOR 3,6 :PRINT "                                                         "
5070 CURSOR 3,7 :PRINT "                                                         "
5080 CURSOR 3,8 :PRINT "                                                         "
5090 CURSOR 3,9 :PRINT "                                             "
5100 CURSOR 30,15: COLOR 7: PRINT "BY PRINCE / PHAZE101": COLOR 1


5110 CURSOR 28,18
5120 COLOR 4:PRINT "PRESS I FOR INSTRUCTIONS":COLOR 1

5130 CURSOR 26,21
5140 PRINT "PRESS ANY KEY TO START THE GAME"
5150 GETKEY K$
5152 IF K$="I" THEN GOSUB23000:GOTO5000



5160 SCREEN CLR
5170 X=0:Y=0
5180 T=INT(RND(0)*30)+20
5190 W=T+1

#--------------------------------------------------------------------------------------------------------------------
# DRAW HUD WALL
#--------------------------------------------------------------------------------------------------------------------

7000 FOR I = 0 TO 24
7010     CURSOR 70,I
7020     COLOR 3: PRINT "";:COLOR 1
7030 NEXT I

#--------------------------------------------------------------------------------------------------------------------
# PLAYER INIT
#--------------------------------------------------------------------------------------------------------------------

9000 X=INT(RND(0)*70)
9010 Y=INT(RND(0)*25)
9020 F=0

9030 FOR L = 0 TO T
9040     IF T(L,0)=X AND T(L,1)=Y THEN F=1
9050 NEXT L

9060 IF F=1 THEN GOTO9000
9070 CURSOR X,Y
9080 COLOR 16: PRINT "";:COLOR 1


#--------------------------------------------------------------------------------------------------------------------
# DALEK INIT
#--------------------------------------------------------------------------------------------------------------------

10000 FOR I = 0 TO T
10010     TX=INT(RND(0)*70)
10020     TY=INT(RND(0)*25)
10030     F=0

10040     FOR L = 0 TO T
10050         IF T(L,0)=TX AND T(L,1)=TY THEN F=1
10060     NEXT L
10070     IF F=1 THEN GOTO10010

10080     CURSOR TX,TY
10090     PRINT "";
10100     T(I,0)=TX : REM DALEK X
10110     T(I,1)=TY : REM DALEK Y
10120     T(I,2)=0  : REM DALEK 255 NOT ACTIVE ANYTHING ELSE ACTIVE
10130 NEXT I

#--------------------------------------------------------------------------------------------------------------------
# REM PLAYER CONTROL - WASD
#--------------------------------------------------------------------------------------------------------------------

11000 GOSUB21000
11010 GETKEY K$
11020 IF K$="W" THEN GOSUB12000:GOSUB16000:GOSUB18000:GOSUB19000
11030 IF K$="A" THEN GOSUB13000:GOSUB16000:GOSUB18000:GOSUB19000
11040 IF K$="S" THEN GOSUB14000:GOSUB16000:GOSUB18000:GOSUB19000
11050 IF K$="D" THEN GOSUB15000:GOSUB16000:GOSUB18000:GOSUB19000
11060 IF K$="T" THEN GOSUB17000:GOSUB16000:GOSUB18000:GOSUB19000
11070 GOSUB20000
11080 GOSUB21000
11090 GOSUB22000
11100 IF W=0 OR W=255 THEN CURSOR 20,20:PRINT "PRESS A KEY TO START THE GAME":GETKEY K$:GOTO5000
11110 GOTO11010
11120 END


#-----------------------------------------------------------------------------------------------------------------------
# PLAYER MOVE UP
#-----------------------------------------------------------------------------------------------------------------------

12000 CURSOR X,Y
12010 PRINT " ";
12020 IF Y>0 THEN Y=Y-1
12030 CURSOR X,Y
12040 COLOR 16: PRINT "";:COLOR 1
12050 RETURN

#--------------------------------------------------------------------------------------------------------------------
# PLAYER MOVE LEFT
#--------------------------------------------------------------------------------------------------------------------


13000 CURSOR X,Y
13010 PRINT " ";
13020 IF X>0 THEN X=X-1
13030 CURSOR X,Y
13040 COLOR 16: PRINT "";:COLOR 1
13050 RETURN

#--------------------------------------------------------------------------------------------------------------------
# PLAYER MOVE DOWN
#--------------------------------------------------------------------------------------------------------------------


14000 CURSOR X,Y
14010 PRINT " ";
14020 IF Y<24 THEN Y=Y+1
14030 CURSOR X,Y
14040 COLOR 16: PRINT "";:COLOR 1
14050 RETURN


#--------------------------------------------------------------------------------------------------------------------
# PLAYER MOVE RIGHT
#--------------------------------------------------------------------------------------------------------------------

15000 CURSOR X,Y
15010 PRINT " ";
15020 IF X<69 THEN X=X+1
15030 CURSOR X,Y
15040 COLOR 16: PRINT "";:COLOR 1
15050 RETURN

#--------------------------------------------------------------------------------------------------------------------
# DALEK MOVE TOWARDS PLAYER
#--------------------------------------------------------------------------------------------------------------------

16000 FOR I = 0 TO T
16010     IF T(I,2) <> 255 THEN BEGIN
16020         TX=T(I,0)
16030         TY=T(I,1)
16040         CURSOR TX,TY
16050         PRINT " ";

16060         IF TX>X THEN TX=TX-1
16070         IF TX<X THEN TX=TX+1
16080         IF TY>Y THEN TY=TY-1
16090         IF TY<Y THEN TY=TY+1

16100         CURSOR TX,TY
16110         PRINT "";
16120         T(I,0)=TX
16130         T(I,1)=TY

16140    BEND
16150 NEXT I
16160 RETURN


#--------------------------------------------------------------------------------------------------------------------
# PLAYER JUMP
#--------------------------------------------------------------------------------------------------------------------

17000 CURSOR X,Y
17010 PRINT " ";
17020 X=INT(RND(0)*70)
17030 Y=INT(RND(0)*25)
17040 CURSOR X,Y
17050 COLOR 16: PRINT "";:COLOR 1
17060 RETURN

#--------------------------------------------------------------------------------------------------------------------
# DALEK COLLIDES WITH OTHER DALEK
#--------------------------------------------------------------------------------------------------------------------

18000 FOR L = 0 TO T-1
18010     IF T(L,2)<>255 THEN BEGIN
18020         TX=T(L,0)
18030         TY=T(L,1)

18040         FOR I = L+1 TO T
18050             IF T(I,2)<>255 THEN BEGIN
18060                 ZX=T(I,0)
18070                 ZY=T(I,1)

18080                 IF TX=ZX AND TY=ZY THEN BEGIN
18090                     T(L,2)=255
18100                     T(I,2)=255
18110                     CURSOR TX,TY
18120                     PRINT "*";
18130                 BEND
18140             BEND
18150         NEXT I
18160     BEND
18170 NEXT L
18180 RETURN

#--------------------------------------------------------------------------------------------------------------------
# DALEK COLLIDES WITH A DEAD DALEK
#--------------------------------------------------------------------------------------------------------------------

19000 FOR L = 0 TO T
19010     IF T(L,2)=255 THEN BEGIN
19020         TX=T(L,0)
19030         TY=T(L,1)

19040         FOR I = 0 TO T
19050             IF T(I,2)<>255 THEN BEGIN
19060                 ZX=T(I,0)
19070                 ZY=T(I,1)

19080                 IF TX=ZX AND TY=ZY THEN BEGIN
19090                     T(I,2)=255
19100                     CURSOR TX,TY
19110                     PRINT "*";
19120                 BEND
19130             BEND
19140         NEXT I
19150     BEND
19160 NEXT L
19170 RETURN

#--------------------------------------------------------------------------------------------------------------------
# PLAYER WINS
#--------------------------------------------------------------------------------------------------------------------

20000 W=0
20010 FOR L = 0 TO T
20020     IF T(L,2)<>255 THEN BEGIN
20030         W=W+1
20040     BEND
20050 NEXT L
20060 IF W=0 THEN CURSOR 30,12: PRINT "PLAYER WINS";
20070 RETURN

#--------------------------------------------------------------------------------------------------------------------
# HUD
#--------------------------------------------------------------------------------------------------------------------

21000 CURSOR 72,1:COLOR 7:PRINT "DALEK"
21010 CURSOR 74,2:COLOR 3:PRINT USING "##";W;:COLOR 1
21020 RETURN


#--------------------------------------------------------------------------------------------------------------------
# PLAYER COLLIDES WITH OTHER DALEK
#--------------------------------------------------------------------------------------------------------------------

22000 FOR L = 0 TO T
22010     TX=T(L,0)
22020     TY=T(L,1)
22030     IF TX=X AND TY=Y THEN BEGIN
22040        CURSOR X,Y
22050        COLOR 2: PRINT " ";:COLOR 1

22060        CURSOR 30,12
22070        COLOR 7:PRINT "GAME OVER":COLOR 1
22080        W=255
22090     BEND

22100 NEXT L
22110 RETURN

#--------------------------------------------------------------------------------------------------------------------
# INSTRUCTIONS
#--------------------------------------------------------------------------------------------------------------------

23000 SCREEN CLR:COLOR 3
23010 CURSOR 3,1 :PRINT "                                      "
23020 CURSOR 3,2 :PRINT "                                                         "
23030 CURSOR 3,3 :PRINT "                                                         "
23040 CURSOR 3,4 :PRINT "                                                         "
23050 CURSOR 3,5 :PRINT "                                              "
23060 CURSOR 3,6 :PRINT "                                                         "
23070 CURSOR 3,7 :PRINT "                                                         "
23080 CURSOR 3,8 :PRINT "                                                         "
23090 CURSOR 3,9 :PRINT "                                             "

23100 COLOR 7

23110 CURSOR 5,11:PRINT "AVOID THE DALEK."
23120 CURSOR 5,12:PRINT "MAKE THE DALEK CRASH INTO EACH OTHER."
23130 CURSOR 5,13:PRINT "TELEPORT TO AVOID THE DALEK BUT IT CAN ALSO A DALEK LOCATION.": COLOR 3

23140 CURSOR 30,15:PRINT "USE THE FOLOWING KEYS:":COLOR 4

23150 CURSOR 35,17:PRINT "PRESS W FOR UP"
23160 CURSOR 35,18:PRINT "PRESS A FOR LEFT"
23170 CURSOR 35,19:PRINT "PRESS S FOR DOWN"
23180 CURSOR 35,20:PRINT "PRESS D FOR RIGHT"
23190 CURSOR 35,21:PRINT "PRESS T FOR TELEPORT"

23200 CURSOR 26,23:COLOR 1
23210 PRINT "PRESS ANY KEY TO EXIT INSTRUCTIONS";
23220 GETKEY K$
23230 RETURN